/* $Id: sqlmsg.m,v 1.1.6.1.4.2.2.2.2.10.4.1 2015/06/15 19:08:27 sasgus Exp $ */
/*-------------------------------------------------------------------
 * Copyright (c) 1987 by SAS Institute Inc, Cary NC  27512  USA
 *
 * NAME:      sqlmsg.m
 * PURPOSE:   Defines messages sql prepare phase
 *-----------------------------------------------------------------*/

# M_HELLO       %3zThis is an experimental release of PROC SQL.
# M_NOBRG       %1zDynamic bridge fails.
# M_NOGLOB      %2zThis SAS global statement is not supported
!               in PROC SQL. It has been ignored.
# M_PARSE       %n%3zStatement parses as:
# M_TIMER       TIMER: %s used cpu=%ld wall=%ld io=%ld pgf=%ld
!               m1=%ld m2=%ld m3=%ld

/*-----------------------------
   sql.c message section
-----------------------------*/

# M_NOTIMPL     reuse
# M_SNENOEXEC1  %3zStatement not executed due to NOEXEC option.
# M_SNENOEXEC2  %3z%mPROC SQL set option NOEXEC and will
!               continue to check the syntax of statements.
# M_NOTIMPLCMT  %3z%mThe COMMIT statement is not implemented
!               in PROC SQL.
# M_NOTIMPLGRT  %3z%mThe GRANT statement is not implemented
!               in PROC SQL.
# M_NOTIMPLRBK  %3z%mThe ROLLBACK statement is not implemented
!               in PROC SQL.
# M_NOTIMPLSET  %3z%mThe SET statement is not implemented
!               in PROC SQL.
# M_VALID       %3zPROC SQL statement has valid syntax.

# M_DBGTREE1    %nTree as parsed.
# M_DBGTREE2    %nTree as planned.

# M_DBG1        reuse
# M_DBG2        %nsql: statement as parsed.
# M_DBG3        %1zStatement code %d(%s) not done yet.
# M_DBG4        reuse
# M_DBG5        reuse

/*-----------------------------
   sqlaggr.c message section
-----------------------------*/

# M_AGGRGBYXF   %2z%mA GROUP BY clause has been transformed into an
!               ORDER BY clause because neither the SELECT clause nor
!               the optional HAVING clause of the associated
!               table-expression referenced a summary function.
# M_AGGRNAGGNS  %1zSummary functions nested in this way are
!               not supported.
# M_AGGRSFR     %1z%mSummary functions are restricted to the SELECT
!               and HAVING clauses only.
# M_AGGRGBYTA   %3z%mA GROUP BY clause has been discarded because
!               neither the SELECT clause nor the optional HAVING
!               clause of the associated table-expression referenced
!               a summary function.

# M_AGGRDBG1    sqlaggr: summary functions on what?
# M_AGGRDBG2    sqlaggr: fnexpr->code is not an SQL_ANAM.
# M_AGGRDBG3    %nsqlaggr: Tree before summary function extraction.
# M_AGGRDBG4    %nsqlaggr: Tree after summary function extraction.

/*-----------------------------
   sqlasgn.c message section
-----------------------------*/

# M_NOCDMATCH    %1z%mComposite data is not matched with another
!                composite with the same number of columns.
# M_CFMTRQRD     %1zCharacter expression requires a character format.
# M_NFMTRQRD     %1zNumeric expression requires a numeric format.
# M_UPDEXPRQRD   reuse
# M_ASGNBAD_CONC %1zConcatenation (||) requires character operands.
# M_CCSRESTRICT  %2zConcatenated strings can be at most 32767 characters.
# M_TFCDIFFTYPES %1zTrue/False components are of different types.
# M_NTYPESRQRD   %1zExpression using %s requires numeric types.

/*-----------------------------------------------------------------*/
/*-- these messages describe the operator, and are spliced into  --*/
/*-- messages M_NTYPESRQRD above. The text is limited to 40 char --*/
/*-----------------------------------------------------------------*/
# M_ASGNBAD_HUH  unknown
# M_ASGNBAD_ADD  addition (+)
# M_ASGNBAD_SUB  subtraction (-)
# M_ASGNBAD_MUL  multiplication (*)
# M_ASGNBAD_DIV  division (/)
# M_ASGNBAD_NEG  negation (-)
# M_ASGNBAD_POW  exponentiation (**)
# M_ASGNBAD_POS  a leading plus sign (unary plus sign)

# M_ASGNBAD_IN   IN
# M_ASGNBAD_BETW BETWEEN
# M_ASGNBAD_ISNL IS NULL
# M_ASGNBAD_NTNL IS NOT NULL

# M_ASGNBAD_CEQ  equals (=)
# M_ASGNBAD_CNE  not equals (^=)
# M_ASGNBAD_CLT  less than  (<)
# M_ASGNBAD_CLE  less than or equal (<=)
# M_ASGNBAD_CGT  greater than (>)
# M_ASGNBAD_CGE  greater than or equal (>=)

# M_ASGNBAD_MIN  minimum of (><)
# M_ASGNBAD_MAX  maximum of (<>)
/*-----------------------------------------------------------------*/
/*-- end of section for messages to describe the operator        --*/
/*-----------------------------------------------------------------*/


# M_CDIFFTYPES   %1z%mExpression using %s has components that are of
!                different data types.
# M_CCRESTRICT1  %1z%mComposite comparison must be paired with subquery
!                or composite comparison.
# M_CCRESTRICT2  %1z%mComposite comparison must be paired with subquery
!                or composite comparison that has the same number of
!                items.
# M_CECDIFFTYPES %1z%mComposite expression components are of different
!                data types.
# M_SFNARQRD     %1z%mThe %8b summary function requires a numeric
!                argument.
# M_VINSERT      reuse
# M_VNOMATCH     %1z%mValue %d of VALUES clause %d does not match
!                the data type of the corresponding column in the
!                object-item list (in the SELECT clause).
# M_VNOTONLIST   %1z%mColumn %*s  is not on the list of columns to be
!                inserted.
# M_INVCASGN     %1z%mIt is invalid to assign a character expression to
!                a numeric value using the SET clause.
# M_INVNASGN     %1z%mIt is invalid to assign a numeric expression to a
!                character value using the SET clause.
# M_CEXPTRUNC    %2z%mCharacter expression will be truncated when
!                assigned to character column %*s.
# M_SINSERT      reuse
# M_SNOMATCH     %1z%mValue %d on the SELECT clause does not match the
!                data type of the corresponding column listed after the
!                INSERT table name.
# M_NOLOCFUNC    %1zFunction %*s could not be located.
# M_NOSUPPFUNC   %1zThe %*s class of functions is not supported
!                in PROC SQL.
# M_FMINARGS     %1zFunction %*s requires at least %d argument(s).
# M_FMAXARGS     %1zFunction %*s requires at most %d argument(s).
# M_EXPRQRD      reuse
# M_COLDIFFTYPES %1z%mColumn %d from the first contributor of %s is not
!                the same type as its counterpart from the second.
# M_FMTLOADPROB  %1zFormat %*s could not be loaded.
# M_BADWIDTH     %1z%mThe width value for %*s is out of bounds. It
!                should be between %d and %d.
# M_BADDEC       %1z%mThe decimal value for %*s is out of bounds. It
!                should be between %d and %d.
# M_CARGRQRD     %1z%mCharacter format %*s in PUT function requires a
!                character argument.
# M_NARGRQRD     %1z%mNumeric format %*s in PUT function requires a
!                numeric argument.
# M_CARGRQRD2    %1zINPUT function requires a character argument.
# M_CEXPRNVALID  %1zA Composite expression (usually a subquery) is used
!                incorrectly in an expression.
# M_WHENERROR1   %1z%mOperand of WHEN clause %d is not the
!                same data type as the CASE operand.
# M_WHENERROR2   %1z%mResult of WHEN clause %d is not the
!                same data type as the preceding results.
# M_BADINTO      %2z%mINTO clause that is not in the outermost query
!                block will be ignored.
# M_INTOMORE     %2z%mINTO clause specifies more host variables than
!                columns listed in the SELECT clause.  Surplus
!                host variables will not be set.
# M_INTOLESS     %2z%mINTO clause specifies fewer host variables than
!                columns listed in the SELECT clause.
# M_CLSCERR      %1z%mThe COALESCE function requires its
!                arguments to be of the same data type.
# M_UPDEXPRQRDC  %1z%m%32b, a character column, can only be updated
!                with a character expression.
# M_UPDEXPRQRDN  %1z%m%32b, a numeric column, can only be updated
!                with a numeric expression.
# M_VINSERTLESS  %1z%mVALUES clause %d attempts to insert fewer
!                columns than specified after the INSERT table name.
# M_VINSERTMORE  %1z%mVALUES clause %d attempts to insert more
!                columns than specified after the INSERT table name.
# M_SINSERTLESS  %1z%mAttempt to insert fewer columns than specified
!                after the INSERT table name.
# M_SINSERTMORE  %1z%mAttempt to insert more columns than specified
!                after the INSERT table name.
# M_EXPRQRDC     %1z%mFunction %*s requires a character expression as
!                argument %d.
# M_EXPRQRDN     %1z%mFunction %*s requires a numeric expression as
!                argument %d.
# M_ASGNBAD_LIKE %1zLIKE operator requires character operands.
# M_ASGNBAD_CONT %1zCONTAINS operator requires character operands.
# M_ASGNINS_NOV  %1zInsert table has no columns. PROC SQL requires
!                any table that it processes to have at least 1 column.
# M_ASGNBAD_SDX  %1zSOUNDS-LIKE (=*) operator requires character
!                operands.

# M_ASGNDBG1     %nsqlasgn: Tree before resolving anames.
# M_ASGNDBG2     %nsqlasgn: Tree after resolving anames. pass %d.
# M_ASGNDBG3     sqlasgn(lookup_tag) found not a SQL_SYM.
# M_ASGNDBG4     %nsqlasgn: item on comp/asgn list not SYM.
# M_ASGNDBG5     sqlasgn: Set what vname? name->code is neither an
!                SQL_SYM nor an SQL_ANAM.
# M_ASGNDBG6     asgn_view: narg on OBJ != narg on source OBJ.
# M_ASGNDBG7     asgn_view: OBJ not ASGN or LEAF.

/*-----------------------------
   sqldesc.c message section
-----------------------------*/

# M_STMTREADSLIK %3zStatement reads like:
# M_NOEXSTNGVIEW %1zSQL view %8b.%32b does not exist.
# M_NODEFNEDVIEW %3zSQL view %8b.%32b is defined as:

# M_DESCDBG1     %nsqldesc: say this tree.
# M_DESCDBG2     %nsay_selop: unknown select operator.

/*-----------------------------
   sqldfr.c message section
-----------------------------*/

# M_NOJCONTRIBS  %1zNo contributing tables listed on join condition.
# M_ORDERBY      %3z%mThe query as specified involves ordering by
!                an item that doesn't appear in its SELECT clause.
# M_ASGNNESTING  %1zAssignments are nested more than 50 times.
# M_TOOMANYCOLS  reuse
# M_POSCNUMRQRD  reuse
# M_GBYEXPSUMFNC %1zGROUP BY clause contains a summary function,
!                which is not allowed.
# M_2MANYCOLSGB  %1z%mThere are only %d columns to GROUP BY. %d is too
!                large.
# M_2MANYCOLSOB  %1z%mThere are only %d columns to ORDER BY. %d is too
!                large.
# M_PCNUMRQRDGB  %1zGROUP BY clause requires a positive column number.
# M_PCNUMRQRDOB  %1zORDER BY clause requires a positive column number.

# M_DFRDBG1      reuse
# M_DFRDBG2      sqldfr: ??sym->symtype??
# M_DFRDBG3      sqldfr: who contributes sym %8b with tag %2x?
# M_DFRDBG4      sqldfr: tag problem var %8b:%4x,%4x
# M_DFRDBG5      sqldfr: after where moved to %s.
# M_DFRDBG6      sqldfr: what's on OBJ of SUBC?
# M_DFRDBG7      sqldfr: should be SYM.
# M_DFRDBG8      %nsqldfr: Tagged Tree before dataflow resolution.
# M_DFRDBG9      %nsqldfr: Tagged Tree after sort OBJ copied.
# M_DFRDBG10     %nsqldfr: Just before postorder for %s.
# M_DFRDBG11     %nsqldfr: Just after postorder for %s.
# M_DFRDBG12     %nsqldfr: Just before preorder for %s.
# M_DFRDBG13     %nsqldfr: Just after stuff for filter.
# M_DFRDBG14     %nsqldfr: Just before stuff for join.
# M_DFRDBG15     %nsqldfr: Just before demand all vars for %s.
# M_DFRDBG16     %nsqldfr: Just after sort/aggr stuff.
# M_DFRDBG17     %nsqldfr: Just after demand all vars.
# M_DFRDBG18     %nsqldfr: Just after preorder for %s.
# M_DFRDBG19     %nsqldfr: Tagged Tree after dataflow resolution.
# M_DFRDBG20     %nsqldfr: after fudges for %s.

/*-----------------------------
   sqldmst.c message section
-----------------------------*/

# M_VIEWOUTPUT   %3zSQL view %8b.%*s has been defined.
# M_VIEWNOUTPUT  %1zSQL view was not defined due to errors.
# M_CANNOTALTERC %1zYou cannot alter '%*s' to be a character column.
# M_CANNOTALTERN %1zYou cannot alter '%*s' to be a numeric column.
# M_MPLYDEFDVAR  %2z%mColumn %*s is defined on more than one table.
!                The definition of the column in the first table has
!                been used.
# M_WRITEMODFTBL %1zThe table %32b.%*s was not altered due to error
!                condition.
# M_DROPTHISSTUF %3zProcess a DROP statement.
# M_NOTDELETED   %2z%s %8b.%*s has not been dropped.
# M_WASDELETED   %3z%s %8b.%*s has been dropped.
# M_INDEXVARNAME %1z%mFor a simple index, the index name must be the
!                same as the column name.
# M_SNDXDEFINED  %3zSimple index %*s has been defined.
# M_CNDXDEFINED  %3zComposite index %*s has been defined.
# M_INDEXDELETED %3zIndex %32b has been dropped.
# M_NOINDEXNAMED %2zThere is no index named %32b.
!                It has not been dropped.
# M_DMSTNODSVARS %1z%mPROC SQL requires any created table to have at
!                least 1 column.
# M_DMSTBADDROP  reuse
# M_DMST_FMTC    %1z%mCharacter column %*s requires a character
!                format specification.
# M_DMST_FMTN    %1z%mNumeric column %32b requires a numeric
!                format specification.
# M_DMST_INFC    %1z%mCharacter column %*s requires a character
!                informat specification.
# M_DMST_INFN    %1z%mNumeric column %32b requires a numeric
!                informat specification.
# M_ALTNOCOL     %2zColumn %*s does not exist, DROP request ignored for
!                this column.
# M_CANTALTVIEW  %1zSQL view %8b.%32b cannot be altered.
# M_DMSTBADAS    %1zSAS data set options for the table being created
!                may not include column definitions.
# M_TBLVARCRE    %3zTable %8b.%*s created, with %ll rows and %d columns.
# M_TBLALTER     %3zTable %8b.%*s was the temporary copy of the table
!                being altered.
# M_DMSTBADVOPT  %2zSAS data set options are not permitted for SQL
!                views.
!                Options '%s' have been ignored for SQL view %8b.%*s.


# M_DMSTDBG1     reuse
# M_DMSTDBG2     cr_table: %d cols were copied from like tables.
# M_DMSTDBG3     %2zThe UNIQUE and NOT NULL constraints are not
!                implemented in PROC SQL.  You can force a column to
!                be unique by creating a UNIQUE index on it.
# M_DMSTDBG4     %nsqlcrea: Create/Modify this TABLE.

/*-----------------------------
   sqlinit.c message section
-----------------------------*/

# M_INITDBG1     sqlsti: pools not NULL.

/*-----------------------------
   sqlmain.c message section
-----------------------------*/

# M_INSUFFMEMORY %1zPROC SQL statement aborted due to
!                insufficient memory.

/*-----------------------------
   sqlpars.c message section
-----------------------------*/

# M_DETAILSPLUS  %2zdetails+ not done yet.
# M_DETAILSMINUS %2zdetails- not done yet.

# M_PARSDBG1     %nSQL: %s narg=%2d semarg=%3d word=%*s
# M_PARSDBG2     %nSQL: %s narg=%2d semarg=%3d word=%*s
# M_PARSDBG3     SQLPARS: unknown semantic action %d.

/*-----------------------------
   sqlpbrn.c message section

   NOTE: the following message
         will eventually be in
         a common section as
         this can occur in
         many routines
-----------------------------*/

# M_OUTOFMEMORY  reuse

# M_PBRNDBG1     sqlpbrn: unable to handle contrib # %d.
# M_PBRNDBG2     %nsqlpbrn: Just before building SQL_REPS nodes.
# M_PBRNDBG3     %nsqlpbrn: Just after building SQL_REPS nodes.

/*-----------------------------
   sqlpjd.c message section
-----------------------------*/

# M_PJDDBG1      %nsqlpjd: Tree before Join Splits.
# M_PJDDBG2      sqlpjd: REPS node w/a null non-contrib(s) list.
# M_PJDDBG3      %nsqlpjd: 'best' expression is:
# M_PJDDBG4      sqlpjd: tag %d,%d,%d, type %d, size %f, n %d.
# M_PJDDBG5      %nsqlpjd: Tree after Join Splits.
# M_PJDDBG6      push_join: push data sets: tag=%d, d0=%d, d1=%d.
# M_PJDDBG7      push_smallest: push smallest 2 data sets.
# M_PJDDBG8      push_complex: complex join expression.
# M_PJDDBG9      guess_size: guess_size for %4b?
# M_PJDDBG10     %mguess_size: size(%4b): nobs(predicted)=%g, lrecl=%ld,
!                restrict=%g, size=%g.

/*-----------------------------
   sqlplan.c message section
-----------------------------*/

# M_REMERGE      %3z%mThe query requires remerging summary statistics
!                back with the original data.

# M_CANTFINDSYM  %1z%msqlplan internal error:
!                Cannot find symbol %*s, var=%d, tag=%d.
!                This message can be caused by attempting to make
!                correlated references between two different items
!                on a single FROM clause.

# M_unused       unused
# M_EXECNI       %1z%s exec not implemented.
# M_PLANMAXLEN   %1zSELECT DISTINCT cannot handle an output list that
!                has a size greater than %d characters. Your request
!                contained %ld characters.
# M_PLANDICT     %3zError occurred while allocating temporary index
!                for IN subquery.

# M_PLANMSG1     %*s.
# M_PLANMSG2     %*s:%d,~
# M_PLANMSG3     %*s.

# M_PLANDBG1     %nsqlplan: Tree Before Plan.
# M_PLANDBG2     %nsqlplan: Tree after do_sins.
# M_PLANDBG3     %nsqlplan: Tree after do_update.
# M_PLANDBG4     %nsqlplan: Tree after do_step.
# M_PLANDBG5     %nsqlplan: Tree after subq details resolved.
# M_PLANDBG6     %nsqlplan: Tree After Symbol resolution.
# M_PLANDBG7     %nsqlplan: find_sym, sym is NULL.
# M_PLANDBG8     %nsqlplan: find_sym, u is NULL.
# M_PLANDBG9     %n%mdo_join: (n,s,r) c0=%g %g %g c1=%g %g %g
# M_PLANDBG10    %ndo_join: %3zplanner forced to choose
!                %s for join.
# M_PLANDBG11    %3zPROC SQL planner chooses merge join.
# M_PLANDBG12    %ndo_join:  find_jccs() aborted.
# M_PLANDBG13    %ndo_join:  ins_sort() aborted for %s.
# M_PLANDBG14    %3zPROC SQL planner chooses sequential loop join.
# M_PLANDBG15    %ndo_step: SQL_OBJ item not SQL_SYM.
# M_PLANDBG16    %ndo_step: what's on 5,6,7?
# M_PLANDBG17    %ndo_step: %3z%d temporaries in step.
# M_PLANDBG19    do_subcall: subparm should be a SYM/SUBP.
# M_PLANDBG20    %3z%d correlated cols in subquery.
# M_PLANDBG21    %ndo_setop: insert_uniq failed for %s.
# M_PLANDBG22    %nfind_jccs: Invalid code in equijoin subtree.
# M_PLANDBG23    %n***** JOIN COLUMN CORRESPONDENCE(s) *****%n
# M_PLANDBG24    %n%mmake_otr0: sqlget(ceq,0)->tag = %02x,
!                outertag = %02x.
# M_PLANDBG25    %n**rmdtected: OBJ clause is NULL.
# M_PLANDBG26    %n***is_aggr: defining expr for <%s> is NULL .%n
# M_PLANDBG27    %n***is_groupby: <%s> is not a SYM-A or SYM-V.%n
# M_PLANDBG28    %ndo_sins: %d cols to be inserted.
# M_PLANDBG29    %ndo_join:  can_use_jndx() aborted.
# M_PLANDBG30    %3zPROC SQL planner chooses indexed join.
# M_PLANDBG31    %ndo_join:  construct_pmap() aborted.
# M_PLANDBG32    %*s:%d)%n
# M_PLANDBG33    %ndo_join: %3zPROC planner chooses sqxjm, it wasn't
!                possible to use sqxjndx.
# M_PLANDBG34    %nins_sort: %1zcalled on behalf of %s.
# M_PLANDBG35    %nins_sort: %1z%s should be an SQL_REPS node.

/*-----------------------------
   sqlprep.c message section
-----------------------------*/

# M_PREPDBG1    reuse
# M_PREPDBG2    %3zStatement transforms to:
# M_PREPDBG3    %nData Set Tags.
# M_PREPDBG4    Data Set %8b.%32b is num=%d and tag=%d. NOBS=%ld,
!               lrecl=%ld.

# M_PREPMSG1    %1z%mThe following columns were not found in the
!               contributing tables:~
# M_PREPMSG2    %*s

/*-----------------------------
   sqlrsem.c message section
-----------------------------*/

# M_SUBQNOTIN    reuse
# M_SUBQNOTPART  reuse
# M_COMPOSBAD    %1z%mComposition <<?,?>> must be used in
!                conjunction with a comparison operator.

# M_RSEMDBG1     %nsqlrsem: Tree before early semantic checks.
# M_RSEMDBG2     %nsqlrsem: Tree after early semantic checks.

/*-----------------------------
   sqlrslv.c message section
-----------------------------*/

# M_TOOMANYDS    %1z%mA maximum of 16 tables can be processed
!                in a single PROC SQL statement.
# M_COULDNOTEXP  %1z%mCould not expand %*s.*,
!                correlation name not found.
# M_MORETHAN1    %2zCorrelation name %*s identifies more than one table.
# M_UNRESOLVED   %1zUnresolved reference to table/correlation name %*s.

# M_VMORETHAN1   %1z%mColumn %*s.*s was found in more than
!                one table in the same scope.
# M_AMBIGREF     %1z%mAmbiguous reference, column %*s is in more than
!                one table.
# M_VNOTEXIST    %1z%mColumn %*s does not exist in the INSERT table.
# M_STARWRONG    %1z* used for a function other than COUNT.
# M_STARILLEGAL  %1z* used in an illegal position.
# M_UMORETHAN1   %1zColumn %*s has been updated more than once.
# M_VIEWDEFW     %2zSQL view definition specifies %d column names, but
!                selects %d columns from its underlying tables.

# M_RSLVNOCVAR   %1z%mColumn %*s could not be found in the table
!                identified with the correlation name %*s.
# M_RSLVNODSVARS %1z%mTable %8b.%*s doesn't have any columns. PROC SQL
!                requires each of its tables to have at least 1 column.
# M_BLOWFROMN    %1zQuery is too complex to be processed. It references
!                more than 16 tables.
# M_NOVWDSOPT    %1zUnable to process SAS data set options for
!                SQL view %8b.%*s.
# M_RSLVNOVVAR   reuse
# M_RSLVMVVAR    reuse
# M_RSLVALIAS    reuse


# M_RSLVDBG1    %nsqlrslv: Tree as parsed.
# M_RSLVDBG2    %nsqlrslv: table/view details resolved.%n
# M_RSLVDBG3    %nsqlrslv: done.%n
# M_RSLVDBG4    %nrslv_ds: done for arg %d.%n
# M_RSLVDBG5    %nrslv_view: do this.%n.
# M_RSLVDBG6    %nrslv_view: done.%n
# M_RSLVDBG7    %nrslv_var: preorder before step %s.%n
# M_RSLVDBG8    %nrslv_var: what's on FROM?
# M_RSLVDBG9    %nrslv_var: postorder after step %s.%n
# M_RSLVDBG10   %ndsopen: Opened %8b.%*s...for %s.
# M_RSLVDBG11   %nrslv_asgn: assigns done.%n
# M_RSLVDBG12   %nrslv_star: tree before stars expanded.%n
# M_RSLVDBG13   %ncopy_obj: copy what?
# M_RSLVDBG14   %nlook_ds: what's on FROM clause?
# M_RSLVDBG15   %nrslv_step_var: do this step.%n
# M_RSLVDBG16   %nrslv_step_var: done.%n
# M_RSLVDBG17   , alias=%8b.

/*-----------------------------
   sqlrsop.c message section
-----------------------------*/

# M_RSOPATLEAS1 %1z%mAt least one column name must match
!               when CORRESPONDING is present.
# M_RSOPNULLEXT %2zA table has been extended with null columns to
!               perform the %s set operation.

# M_RSOPDBG1    %nsqlrsop: setop is %s.
# M_RSOPDBG2    %nsqlrsop: Entry tree.
# M_RSOPDBG3    sqlrsop: CORRESPONDING modifier is incorrect.
# M_RSOPDBG4    sqlrsop: Unknown set operator.
# M_RSOPDBG5    %nsqlrsop: Exit tree.


/*-----------------------------
   sqlsubq.c message section
-----------------------------*/

# M_BADCORR     %1zCorrelated reference to column %*s is not
!               contained within a subquery.

# M_LSUBQDBG1   %nSQLSUBQ: transform this subquery.
# M_LSUBQDBG2   %nSQLSUBQ: transformed, after SUBCALL processing.
# M_LSUBQDBG3   %nbuild_list: Subquery shopping list (%d subqueries).
# M_LSUBQDBG4   %n%mshow_list: %*tsubq=%p:%p, an=%p:%d, ex=%p:%d,
!               class=%2xx.
# M_LSUBQDBG5   %nnest_nj: %p:%p. %s correlated.
# M_LSUBQDBG6   %nnest_nj: subquery opcode=%s ??
# M_LSUBQDBG7   %nnest_nj: FROM clauses are joined.
# M_LSUBQDBG8   %nnest_nj: WHERE clauses are connected with AND operators.
# M_LSUBQDBG9   %nnest_nj: not exist?
# M_LSUBQDBG10  %nnest_nj: done.
# M_LSUBQDBG11  %nnest_ja2: %p:%p.
# M_LSUBQDBG12  %nnest_ja2: join created.
# M_LSUBQDBG13  %nnest_ja2: done.


/*-----------------------------
   sqlsym.c message section
-----------------------------*/

# M_LSYMDBG1    %nsqlsymf: t->ds is NULL.
# M_LSYMDBG2    %msqlsymd: Symbol %p: %4s -- name=%8s,%d ds=%p tag=%2x
!               tl=%d,%d.


/*-----------------------------
   sqltok.c message section
-----------------------------*/

# M_DSOPTFIN    %1zUnable to parse data set options.

# M_TOKDBG1     %nSQLTOK: %s identified, t->ident set to 0.
# M_TOKDBG2     %nSQLTOK: butcher's token.
# M_TOKDBG3     %nSQLTOK: '%2b' identified as doublet.
# M_TOKDBG4     %n%mSQLTOK:
!               type=%5d,%5d   nb=%2d   ID=%1d   lng=%2d   str=%*s.

/*-----------------------------
   sqltrav.c message section
-----------------------------*/

# M_TRAVNOTMTY  %1zsqltrav stack not empty at stmt end. TOP=%d.

# M_TRAVDBG1    %2ztraversal stack grows by %d to %ld.

/*-----------------------------
   sqlutil.c message section
-----------------------------*/

# M_LUTILDBG1   %nsqlget: get from a leafnode/NULL is foolish!
# M_LUTILDBG2   %nsqltgff: not FROM.
# M_LUTILDBG3   %nsqlsetx: set to a leafnode/NULL is foolish!
# M_LUTILDBG4   %nsqlgetx: get from a leafnode/NULL is foolish!
# M_LUTILDBG5   %nsqltagn: tags the tree please....
# M_LUTILDBG6   %nsqltgu: %8b has 0 tag.
# M_LUTILDBG7   %nsqltagn: tree after tags installed.
# M_LUTILDBG8   %nsqlmem: you asked for %ld memory?

/*-----------------------------
   sqlview.c message section
-----------------------------*/

# M_VOBSOLETE   %1zSQL View %8b.%32b is obsolete.
# M_VRECURSION  %1z%mSQL view %8b.%32b has been referenced more than %d
!               times in this query. Suspected view recursion.

# M_VIEWDBG1    %nsqlvget: retrieves this view.%n
# M_VIEWDBG2    %nsqlvin: Opening SQL view %8b.%32b...use_count=%d.

/*-----------------------------
   sqxbuf.c message section
-----------------------------*/

# M_BUFDBG1     xbini: ctl=%p, size=%ld.
# M_BUFDBG2     xbw1: first page is at %p.
# M_BUFDBG3     xbwnx: page %d is at %p.
# M_BUFDBG4     xbwrt: page %d marked dirty.
# M_BUFDBG5     xbr1: first page is at %p.
# M_BUFDBG6     xbrnx: page %d is at %p.
# M_BUFDBG7     sqxbtrm: bad control block.
# M_BUFDBG8     put_page: page %d written at handle %d.
# M_BUFDBG9     exp_hand: handles increased to %d.
# M_BUFDBG10    dump_ctl: sctl=%p, maxx=%d, curr=%d, ser=%d
# M_BUFDBG11    page handles: n=%d: %m %d
# M_BUFDBG12    xbnot: page %d noted.
# M_BUFDBG13    xbpnt: page %d pointed to. It is at %p.
# M_BUFDBG14    %1zsqxsumg: sqxbpnt() failed.

/*-----------------------------
   sqxcrta.c message section
-----------------------------*/

# M_CRTAERLYTRM %2z%mStatement terminated early due to
!               OUTOBS=%ll option.

# M_CRTADBG1    %1zsqxcrta: unrecognized action %d.


/*-----------------------------
   sqxdisp.c message section
-----------------------------*/

# M_DISPQCANCEL %3zQuery was canceled by attention.
# M_DISPASNRUPT %3zPROC SQL statement interrupted by LOOPS=%ld option.
# M_DISPRUNTIME %1zPROC SQL runtime error for operation=%s.
# M_DISPRTMSG   reuse

# M_DISPDBG1    sqxdisp: PAUSE is not currently supported.
# M_DISPDBG2    sqxdisp: function to be dispatched is null.
# M_DISPDBG3    sqx: calling %s, action = %s(%s) %d.
# M_DISPDBG4    sqxdisp: runtime error popping the stack.
# M_DISPDBG5    sqxsadd: action %d scheduled on %p by:~

/*-----------------------------
   sqxdlt.c message section
-----------------------------*/

# M_DLTERLYTRM  %2z%mStatement terminated early due to
!               OUTOBS=%ll option.

# M_DLTDBG1     xdlt: expects RID_PTR in buffer.
# M_DLTDBG2     %1zsqxdlt: unrecognized action %d.

/*-----------------------------
   sqxexpr.c message section
-----------------------------*/

# M_EXPRONI     %1zsqxexpr: opcode %d not implemented.
# M_EXPRNVARG   %3zInvalid argument %d to function %*s. Missing values
!               may be generated.
# M_EXPRIERR    %1zInternal error with function %*s. Missing values
!               may be generated.

# M_EXPRDBG1    sqxexpr: put subquery result at istack=%d.
# M_EXPRDBG2    reuse
# M_EXPRDBG3    sqxexpr: no parent, but istack not 1 -- it is %d.
# M_EXPRDBG4    sqxexpr: in/notin not done.
# M_EXPRDBG5    Error: sqxexpr: opcode %d not implemented.
# M_EXPRDBG6    Error: sqxexpr: what type of result?
# M_EXPRDBG7    sqxexpr: charres is not done yet....
# M_EXPRDBG8    leafexpr: unrecognized operation %d.
# M_EXPRDBG9    truth: of what?
# M_EXPRDBG10   sqxexpr: IN what? (%d)
# M_EXPRDBG11   reuse
# M_EXPRDBG12   reuse
# M_EXPRDBG13   reuse
# M_EXPRDBG14   subq value stacked:~
# M_EXPRDBG15   leafexpr at istack=%d,~
# M_EXPRDBG16   evaluate %s, i=%d,n=%d,s=%d~
# M_EXPRDBG17   evaluates to:~
# M_EXPRDBG18   value stacked is:~
# M_EXPRDBG19   MISSING
# M_EXPRDBG20   %g
# M_EXPRDBG21   '%*b'


/*-----------------------------
   sqxfil.c message section
-----------------------------*/

# M_FILDBG1     sqxfil: bad resume.
# M_FILDBG2     %1zsqxfil: unrecognized action %d.

/*-----------------------------
   sqxins.c message section
-----------------------------*/

# M_INSERLYTRM  %2z%mStatement terminated early due to
!               OUTOBS=%ll option.
# M_INS_UNDO    %3zDeleting the successful inserts before error noted
!               above to restore table to a consistent state.

# M_INSDBG1     %1zsqxins: unrecognized action %d.


/*-----------------------------
   sqxjm.c message section
-----------------------------*/

# M_JMDBG1      sqxjm:  <%c> is an illegal resume point.
# M_JMDBG2      sqxjm:  problem with sqxbw1() in AC_REOPN.
# M_JMDBG3      sqxjm:  bad state in AC_GETREC.
# M_JMDBG4      sqxjm:  problem with sqxbr1().
# M_JMDBG5      sqxjm:  next outer block doesn't exist.
# M_JMDBG6      sqxjm:  problem with sqxbwnx().
# M_JMDBG7      sqxjm:  problem with sqxbrnx().
# M_JMDBG8      ctrlbrk:  which_reln has an invalid value.
# M_JMDBG9      sqxjm:  bad u->joinflag.
# M_JMDBG10     sqxjm:  %s record bigger than buffer.%n
# M_JMDBG11     sqxjm:  unrecognized action %d.
# M_JMDBG12     sqxjm:  problem with sqxbw1().

/*-----------------------------
   sqxjsl.c message section
-----------------------------*/

# M_JSLDBG1     sqxjsl: <%c> is an illegal resume point.
# M_JSLDBG2     sqxjsl:  problem with sqxbw1() in AC_REOPN.
# M_JSLDBG3     sqxjsl:  bad state in AC_GETREC.
# M_JSLDBG4     sqxjsl:  problem with sqxbr1().
# M_JSLDBG5     reuse
# M_JSLDBG6     sqxjsl:  next outer block doesn't exist.
# M_JSLDBG7     sqxjsl:  problem with sqxbwnx().
# M_JSLDBG8     reuse
# M_JSLDBG9     sqxjsl:  problem with sqxbrnx().
# M_JSLDBG10    sqxjsl:  outer record bigger than buffer.%n
# M_JSLDBG11    %1zsqxjsl: unrecognized action %d.
# M_JSLDBG12    %1zsqxjsl: bad u->joinflag.
# M_JSLDBG13    %1zsqxjsl: problem with sqxbw1().
# M_JSLDBG14    sqxjsl:  inner record bigger than buffer.%n


/*-----------------------------
   sqxlhd.c message section
-----------------------------*/

# M_LHDDBG1     sqxdcre: keylen = %ld, datalen = %ld, uniq = %s%n
# M_LHDDBG2     sqxdcre: Invalid param(s). keylen = %ld, datalen = %ld%n
# M_LHDDBG3     sqxdcre: %mslot size bigger than max slotsize. slotsize
!               = %ld, max slotsize = %ld%n
# M_LHDDBG4     sqxdcre: not enough mem to allocate LHDICT structure.
# M_LHDDBG5     sqxdcre: linear hash file not opened.
# M_LHDDBG6     sqxdcre: not enough memory to create page bufs.%n
# M_LHDDBG7     sqxdcre: list entry size bigger than max lentsize.
!               lentsize = %ld, max lentsize = %ld%n
# M_LHDDBG8     sqxdcre: not enough memory to create pool entry.%n
# M_LHDDBG9     sqxdcre: not enough memory to create sort specifications.%n
# M_LHDDBG10    sqxdclr: lhd_handle = %08x%n
# M_LHDDBG11    sqxdtrm: lhd_handle = %08x%n
# M_LHDDBG12    sqxdget: page_adr => %ld%n
# M_LHDDBG13    sqxdput: page_adr => %ld%n
# M_LHDDBG14    sqxdput: not enough memory to create page buf.%n
# M_LHDDBG15    expand: lhdict = %08x%n
# M_LHDDBG16    expand: %msort problem.
!               %ll records were input, BUT %ll records were output.
# M_LHDDBG17    expand: poolget() problem.
# M_LHDDBG18    expand: overflow file not opened.%n
# M_LHDDBG19    expand: getpoolrec() problem.
# M_LHDDBG20    get_page: lhdict = %08x, page_to_read = %ld%n
# M_LHDDBG21    get_page: ***PHYSICAL GET OCCURRED***%n
# M_LHDDBG22    put_page: lhdict = %08x, page_to_write = %ld%n
# M_LHDDBG23    put_page: page_to_write not in buffer.
# M_LHDDBG24    get_page: ***PHYSICAL PUT OCCURRED***%n
# M_LHDDBG25    poolget: lhdict = %08x%n
# M_LHDDBG26    flushc: lhdict = %08x%n
# M_LHDDBG27    sqxdfnd: lhd_handle = %08x, SEARCHED FOR keyval = <
# M_LHDDBG28    %02x
# M_LHDDBG29    sqxdfnd: INSPECTED page %ld, slot %d: keyval = <
# M_LHDDBG30    sqxdfnd: *FOUND* keyval = <
# M_LHDDBG31    > on page %ld, slot %d%n
# M_LHDDBG32    sqxdget: lhd_handle = %08x, SEARCHED FOR keyval = <
# M_LHDDBG33    sqxdput: lhd_handle = %08x, TRY TO INSERT keyval = <
# M_LHDDBG34    sqxdput: INSERTED keyval = <
# M_LHDDBG35    > on page %ld, slot %d%n
# M_LHDDBG36    > on page %ld, slot 0%n
# M_LHDDBG37    sqxddel: lhd_handle = %08x, SEARCHED FOR keyval = <
# M_LHDDBG38    sqxdfnd: DELETED keyval = <
# M_LHDDBG39    > on page %ld%n
# M_LHDDBG40    address: INCOMING keyval = <
# M_LHDDBG41    >,  ha = %ld, fsz = %ld, lstpg = %ld%n
# M_LHDDBG42    hash: INCOMING keyval = <
# M_LHDDBG43    >, keylen = %ld, hashval = %08lx%n
# M_LHDDBG44    the dict was expanded by <%ld> pages%n

/*-----------------------------
   sqxmem.c message section
-----------------------------*/

# M_MEMDBG1     %nsqxmem: Stepid %d allocates page at %p.
# M_MEMDBG2     %nsqxmfre: Stepid %d frees memory at %p.
# M_MEMDBG3     %nsqxmfre: you freed sqxmem that PROC SQL didn't know
!               about.
# M_MEMDBG4     %nsqxmend: %mInternal Error: Stepid %d did not free sqx
!               memory.
# M_MEMDBG5     %nsqxmget: page handle %d not on disk.
# M_MEMDBG6     %nsqxmput: dumpfile not opened.

/*-----------------------------
   sqxnall.c message section
-----------------------------*/

# M_NALLDBG1    %nsqxnall: illegal resume point <%c>.
# M_NALLDBG2    reuse
# M_NALLDBG3    reuse
# M_NALLDBG4    reuse
# M_NALLDBG5    reuse
# M_NALLDBG6    %1zsqxnall: unrecognized action %d.

/*-----------------------------
   sqxotru.c message section
-----------------------------*/

# M_OTRUDBG1    %nsqxotru: illegal resume point <%c>.
# M_OTRUDBG2    %1zsqxotru: unrecognized action %d.

/*-----------------------------
   sqxreps.c message section
-----------------------------*/

# M_REPSDBG1    %nsqxreps: invalid resume point '%c'.
# M_REPSDBG2    %nsqxreps: WHERE clause present on an SQL_REPS node.
# M_REPSDBG3    %1zsqxreps: unrecognized action %d.
# M_REPSDBG4    %1zprocess_noncontribs: unrecognized action %d.

/*-----------------------------
   sqxslct.c message section
-----------------------------*/

# M_SLCTERLYTRM %2z%mStatement terminated early due to
!               OUTOBS=%ld option.
# M_SLCTFMTLPRB %1z%mFormat %8b could not be loaded. The default
!               format will be used.

# M_SLCTNUMBER  Row
# M_SLCTNOPRINT %1zCannot initialize printing subsystem.
# M_SLCTNOPRL   %1zError occurred while printing.

# M_SLCTDBG2    %1zsqxlsct: what's on xsym array?
# M_SLCTDBG4    %1zsqxslct: unrecognized action %d.

/*-----------------------------
   sqxsort.c message section
-----------------------------*/

# M_SORTDBG1    %nsqxsort: illegal resume point <%c>.
# M_SORTDBG2    %nsqxsort:  invalid sort specification.
# M_SORTDBG3    %nsqxsort: %msort problem.  %ll records were input,
!               but %ll records were output.
# M_DLTDBG4     %1zsqxsort: unrecognized action %d.

/*-----------------------------
   sqxsrc.c message section
-----------------------------*/
# M_SRCERLYTRM  %2z%mOnly %ll records were read
!               from %8b.%*s (alias=%*s) due to INOBS= option.

# M_SRCDBG1     %nsqxsrc: what's on OBJ?
# M_SRCDBG2     %nsqxsrc: Just about to push this new tree.
# M_SRCDBG3     %1zsqxsrc: unrecognized action %d.

/*-----------------------------
   sqxstj.c message section
-----------------------------*/

# M_STJDBG1     %nsqxstj: record bigger than buffer.
# M_STJDBG2     sqxstj: EARLY LIST present on store joint.
# M_STJDBG3     sqxstj: WHERE CLAUSE present on store joint.
# M_STJDBG4     sqxstj: OBJEVAL LIST present on store joint.
# M_STJDBG5     %1zsqxstj: unrecognized action %d.

/*-----------------------------
   sqxsuba.c message section
-----------------------------*/

# M_SUBADBG1    %nsqxsuba: SUBQ_SANY: unknown/unexpected 'lastrc'.
# M_SUBADBG2    %nsqxsuba: SUBQ_SALL: unknown/unexpected 'lastrc'.
# M_SUBADBG3    %nsqxsuba: -AC_GETREC: unknown/unexpected 'subq->type'.
# M_SUBADBG4    %1zsqxsuba: unrecognized action %d.

/*-----------------------------
   sqxsubq.c message section
-----------------------------*/

# M_SUBQMT1ROW  %1zSubquery evaluated to more than one row.
# M_CORRVAL     %3zCorrelation values are:
# M_XSUBQNOPUT  %1zError occurred while inserting into temporary index.

# M_XSUBQDBG1   %3zcorrelations %schanged.
# M_XSUBQDBG2   sqxsubq: could not sqxdclr().
# M_XSUBQDBG4   %1zsqxsubq: unrecognized action %d.

/*-----------------------------
   sqxsumc.c message section
-----------------------------*/

# M_SUMCXCPT    %2z%m%8b could not be computed because
!               of overflow/underflow. A missing value is
!               being returned as its result.
# M_SUMCNOIDX   %1z:Unable to create temporary index
!               while processing summary functions.
# M_SUMCNOPUT   %1z:Unable to insert into temporary index
!               while processing summary functions.

# M_SUMCDBG3    sqxsred: zpgt2() failed.
# M_SUMCDBG4    sqxsred: unknown summary function.
# M_SUMCDBG5    sqxspds: sqxdclr() failed.
# M_SUMCDBG6    sqxscds: sqxdtrm() failed.

/*-----------------------------
   sqxsumg.c message section
-----------------------------*/

# M_SUMGSORTP   %1zSort problem. %ld rows were input,
!               BUT %ld rows were output.

# M_SUMGDBG1    grp_remerge: illegal resume point <%c>.
# M_SUMGDBG2    grp_noremerge: illegal resume point <%c>.
# M_SUMGDBG3    %1zsqxsumg: unrecognized action %d.

/*-----------------------------
   sqxsumn.c message section
-----------------------------*/

# M_SUMNDBG1    ngrp_remerge: illegal resume point <%c>.
# M_SUMNDBG2    ngrp_noremerge: illegal resume point <%c>.
# M_SUMNDBG3    %1zsqxsumn: unrecognized action %d.

/*-----------------------------
   sqxuall.c message section
-----------------------------*/

# M_UALLDBG1    sqxuall: illegal resume point <%c>.
# M_UALLDBG2    %1zsqxuall: unrecognized action %d.

/*-----------------------------
   sqxuniq.c message section
-----------------------------*/

# M_UNIQSORTP   %1zSort problem. %ld rows were input,
!               but %ld rows were output.

# M_UNIQDBG1    sqxuniq: illegal resume point <%c>.
# M_UNIQDBG2    sqxuniq: record bigger than buffer.
# M_UNIQDBG3    sqxuniq: unrecognized action %d.

/*-----------------------------
   sqxupd.c message section
-----------------------------*/

# M_UPDERLYTRM  %2zStatement terminated early due to
!               OUTOBS=%ld option.
# M_UPD_UNDO    %3zUndoing successful updates before error noted above
!               to restore table to a consistent state.

# M_UPDDBG1     sqxupd: expects RID_PTR in buffer.
# M_UPDDBG2     sqxupd: unrecognized action %d.

/*-----------------------------
   sqxutil.c message section
-----------------------------*/

# M_XSLCT_NONE  %3zNo rows were selected.
# M_XINS_NONE   %3zNo rows were inserted into %8b.%*s.
# M_XDLT_NONE   %3zNo rows were deleted from %8b.%*s.
# M_XUPD_NONE   %3zNo rows were updated in %8b.%*s.

# M_TBLCREATED   %3zTable %8b.%*s has been created, with %d columns.
# M_TBLMODIFIED  %3zTable %8b.%*s has been modified, with %d columns.

# M_XUTILDBG1   sqxasgn fails.
# M_XUTILDBG2   %nsqxdst: SQSTEP: stepid=%d, stepscope=%d, stepup=%d.
# M_XUTILDBG3   %nsqxdst: Symbols available above, bufleng=%ld.
# M_XUTILDBG4   %nsqxdst: Name %8s, solt=%d %ld %d %d, offset=%ld.
# M_XUTILDBG5   %s: Bad parameter(s).%nneeds = %ld,
!               lrecl = %ld, nvar = %d, sorvd = %8p%n.
# M_XUTILDBG6   sqxsort: record bigger than buffer.
# M_XUTILDBG7   %1z:Error ocurred while reading from temporary sort
!               file.
# M_XUTILDBG8   sqxgsor: recs_read = %ld, recs_out = %ld.
# M_XUTILDBG9   %nsqxdval: %s >>> %g <<<
# M_XUTILDBG10  %nsqxdval: %s >>> %*s <<<
# M_XUTILDBG11  %nsqxsswi: OBJEVAL arg # %d doesn't refer to a switch.
# M_XSUTNOSPACE %1zThere is not enough WORK disk space to store the
!               results of an internal sorting phase.
# M_XUTILDBG13  ~%*s=
# M_XUTILDBG14  %g
# M_XUTILDBG15  '%*s'

/*-----------------------------
   sqxxall.c message section
-----------------------------*/

# M_XALLDBG1    sqxxall: illegal resume point <%c>.
# M_XALLDBG2    reuse
# M_XALLDBG3    reuse
# M_XALLDBG4    reuse
# M_XALLDBG5    reuse
# M_XALLDBG6    sqxxall: unrecognized action %d.


/*-- for sqxjndx.c --*/
# M_JNDXDBG1    %nsqxjndx: illegal resume point <%c>.
# M_JNDXDBG2    %nsqxjndx: what's on OBJ?
# M_JNDXDBG3    %1zsqxjndx: unrecognized action %d.

/*-- for sqltrep.c --*/
# M_TREPDBG1    %.*s:%d)
# M_TREPDBG2    ...overflow tree print...
# M_TREPDBG3    %*s%c-empty-
# M_TREPDBG4    (%g)
# M_TREPDBG5    (%'%*s%')
# M_TREPDBG6    [%8b].%*s opt='%*s'
# M_TREPDBG7    (%d)
# M_TREPDBG8    (jds=%d, tagfrom=%d, flags=%d)
# M_TREPDBG9    (fmt=%*s%d.%d)
# M_TREPDBG10   (%*s)
# M_TREPDBG11   %*s%c-%6s-|
# M_TREPDBG12   p=%p,
# M_TREPDBG13   n=%p,
# M_TREPDBG14   t=%3d,
# M_TREPDBG15   tag=%4x
# M_TREPDBG16   %.*s.
# M_TREPDBG17   -%c-(
# M_TREPDBG18   %s.
# M_TREPDBG19   %.*s:%d
# M_TREPDBG20   ~stat=%d,%d from %*s(%d,%d)
# M_TREPDBG21   ~ss=%4xx
# M_TREPDBG22   ~flag=%2x
# M_TREPDBG23   ~solt=%d %ld %d %d
# M_TREPDBG24   %*s%c-%s
# M_TREPDBG25   ~~~~~~~page(%2d) %p
# M_TREPDBG26   , ser=%4d, dirty=%s, disk_handle=%d.

/*-- for sqlhost.c --*/
# M_HOSTMSG1    %b(%d).
# M_HOSTMSG2    --no traceback available--


/*-- for sqxsut.c --*/
# M_XSUTBADSORT %1zUnable to sort. zsort rc=%d, recsout=%ld. Sort
!               subsystem message follows.
# M_XSUTBADBR1  %1zUnable to rewind sorted data set?

/*---------------------------------------------------------------
   **** OVERFLOW AREA **** (waiting for an sqlm.m change day)
---------------------------------------------------------------*/

/*-- for sqxutil.c --*/
# M_XUTILDBG16  %2zsqxcmp: comparands are of DIFFERENT types!
!               They were treated as if they were of the same type
!               and equal.

/*-- common messages --*/
# M_XIKNOMISS   %3zPROC SQL can not use index %*s of %8b.%*s
!               because it has a NOMISS flag specified.

/*-- for sqlasgn.c --*/
# M_NOCOMPOSITE %1zA subquery cannot select more than one column.

/*-- for sqlaggr.c --*/
# M_AGGRCORR1   %2zA GROUP BY clause has been detected where all
!               of its group-by-items referenced a correlated
!               variable. That entire GROUP BY clause has been
!               discarded.

# M_AGGRCORR2   %2zA GROUP BY clause has been detected where one
!               or more of its group-by-items referenced a
!               correlated variable. Each item making such a
!               reference has been discarded from that clause.

# M_DUPLVIEW    %2zColumn named %*s is duplicated in a
!               select expression (or a view). Explicit
!               references to it will be to the first one.

/*-- for sqlasgn.c --*/
# M_ELSEWHAT    %3z%mA CASE expression has no ELSE clause. Cases not
!               accounted for by the WHEN clauses will result in
!               a missing value for the CASE expression.

/*-- for sqxuniq.c --*/
# M_UNIQDBG4    %1zTables that are to be DISTINCTed must have rows
!               whose lengths are less than or equal to %d bytes.

/*-- for sqxstj.c --*/
# M_STJDBG6     %1zsqxstj: sqxbrnx() failed.

/*-- for sqxuniq.c --*/
# M_UNIQDBG5    %1zsqxuniq: ztrebdf() failed.

/*-- for sqlstmt.c --*/
# M_NORUN       %3z%mPROC SQL statements are executed immediately;
!               The RUN statement has no effect.

/*-- for sqxins.c sqxdlt.c sqxupd.c --*/
# M_XINS_ONE    %3z1 row was inserted into %8b.%*s.
# M_XDLT_ONE    %3z1 row was deleted from %8b.%*s.
# M_XUPD_ONE    %3z1 row was updated in %8b.%*s.

# M_XINS_MANY   %3z%ll rows were inserted into %8b.%*s.
# M_XDLT_MANY   %3z%ll rows were deleted from %8b.%*s.
# M_XUPD_MANY   %3z%ll rows were updated in %8b.%*s.

/*-- sqldmst.c --*/
# M_CANTALTTAB  %1zSQL table %8b.%*s could not be altered because a
!               temporary name for the copy could not be generated.

/*-- sqxmem.c --*/
# M_UTILERR     %3zError was encountered during utility-file processing.
!               You may be able to execute the SQL statement
!               successfully if you allocate more space to the WORK
!               library.

/*-- sqlstmt.c --*/
# M_NOBITS      %1zBit Constants are not supported by SQL.

/*-- sqxins.c --*/
# M_INS_BADUNDO %1zMultiple errors occurred while attempting to
!               restore table to a consistent state. Inserts may
!               be only partially backed out.

/*-- sqxupd.c --*/
# M_UPD_BADUNDO %1zMultiple errors occurred while attempting to
!               restore table to a consistent state. Updates may
!               be only partially backed out.

/*-- esv.c --*/
# M_NONAME      %2zThe SQL View %8b.%32b contains un-named expressions in
!               its select list. SQL will generate internal names using
!               the template _TEMVnnn.

/*-- sqldmst.c --*/
# M_NOIDXOPN    %2zThe Table %8b.%*s resides in a SAS Library
!               that does not support indexing.

/*-- sqlsem.c --*/
# M_NOXLATE     %3zThe Sort Sequence table %8b could not be loaded.
!               The Sort Sequence has been restored to the default
!               sequence.


/*-- sqldmst.c --*/
# M_CANTALTACCV %1zView %8b.%*s cannot be altered.
# M_ADDNEEDSTYP %1zColumn %*s cannot be added without a data type.

/*-- sqldesc.c --*/
# M_TABLCRE8LIK %3zSQL table %8b.%*s was created like:
# M_CANTDESCRIB %1z%8b.%*s.%8b cannot be described by the DESCRIBE
!               TABLE statement.

/*-- sqlmain.c --*/
/*-----------------------------------------------------------------*/
/*-- DONT REORDER THE SENSE OF THE SELECTIONS... CODE IS         --*/
/*-- POSITIONALLY DEPENDENT ON THE ORDERING OF THE SELECTIONS    --*/
/*-- WITHIN EACH MESSAGE.                                        --*/
/*-----------------------------------------------------------------*/
# M_STRBREAK    !Press: !C to continue, !Q to cancel current query,
!               !S to cancel submitted statements,
!               !X to exit SQL procedure.
# M_STRINOBS    !Limit specified by INOBS= option has been reached.
!               !S to stop, !C to continue.
# M_STROUTOBS   !Limit specified by OUTOBS= option has been reached.
!               !S to stop, !C to continue.
# M_STRLOOPS    !Limit specified by LOOPS= option has been reached.
!               !S to stop, !C to continue.


/*-- sqltrep.c --*/
# M_TREPDBG27   -- DICTIONARY.%*s alias=%*s num=%d.

/*-- sqlrslv.c --*/
# M_SOBRDONLY   %1zDICTIONARY.%*s is a read-only table.
# M_SOBNOTABLE  %1z%*s is not a recognized PROC SQL Dictionary Table.

/*-- sqlplan.c --*/
# M_PLAN_SW_A   INFO: %mIndex %*s of SQL table %8b.%*s (alias = %*s)
!               selected for SQL WHERE clause (join) optimization.
# M_PLAN_SW_NA  INFO: %mIndex %*s of SQL table %8b.%*s
!               selected for SQL WHERE clause (join) optimization.
# M_PLAN_NOOPTJ %3z%mThe execution of this query involves performing
!               one or more Cartesian product joins that can not be
!               optimized.

/*-- sqldmst.c --*/
# M_NOINDXVARS  %1z%mIndex %*s cannot be created because a column has
!               not been specified.

/*-- sqpcon.c --*/
# M_CONBADDBMS  %1zA Connection to the %*s DBMS is not currently
!               supported, or is not installed at your site.
# M_CONEXISTS   %1zA Connection to the %*s DBMS(alias=%*s) has already
!               been established.
# M_CONBADVAR   %2zThe number of column names does not match the
!               number of actual columns returned for connection %*s.

/*-- sqlplan.c --*/
# M_PLANDBG36   %3zPROC SQL planner chooses hash join.

/*-- sqxjhsh.c --*/
# M_JHSHDBG1    %1zsqxjhsh: illegal resume point <%c>.
# M_JHSHDBG2    reuse
# M_JHSHDBG3    %1zsqxjhsh: unrecognized action %d.

/*-- sqlrsem.c --*/
# M_BADINTOVIEW %2zINTO clause is ignored in the CREATE VIEW statement.

/*-- sqldesc.c --*/
# M_TABLCRDCLIK %3zSQL table DICTIONARY.%*s was created like:

/*-- sqxjhsh.c --*/
# M_JHSHDBG4  %2zsqxjhsh: key_match: comparands are of DIFFERENT types!
!             They were treated as if they were of the same type
!             and equal.

/*-- sqpcon.c --*/
# M_NOSUCHCON %1zConnection to the %*s  DBMS does not exist.

/*-- sqxsrc.c --*/
# M_SRCDBG4     %1zsqxsrc: unable to find the useful keypart <%*s>.
# M_SRC_V_F_A   %1zThe sort order validation of SQL table
!               %8b.%*s (alias = %*s) failed.

/*-- sqlprep.c --*/
# M_PREPMSG3    %1z%mThe following columns were not found as
!               CALCULATED references in the immediate query:~

/*-- sqlasgn.c --*/
# M_BAD_USER    %1z%mThe USER keyword will have a constant
!               value for all rows in a query. It is not
!               supported on the ORDER BY or GROUP BY clauses.

/*-- sqxjhsh.c --*/
# M_JHSHDBG5    %nsqxjhsh: get_i_xbuf_rec: problem with sqxbr1().
# M_JHSHDBG6    %nsqxjhsh: get_i_xbuf_rec: problem with sqxbrnx().
# M_JHSHDBG7    %nsqxjhsh: get_o_xbuf_rec: problem with sqxbr1().
# M_JHSHDBG8    %nsqxjhsh: get_o_xbuf_rec: problem with sqxbrnx().
# M_JHSHDBG9    %nsqxjhsh: AC_REOPN: outer setup_obb() failed.
# M_JHSHDBG10   %nsqxjhsh: AC_REOPN: inner setup_obb() failed.
# M_JHSHDBG11   %nsqxjhsh: hash table flush failed!%n
# M_JHSHDBG12   %nsqxjhsh: inner blocks flush failed!%n
# M_JHSHDBG13   %nsqxjhsh: put_inner_rec() failed!!!%n
# M_JHSHDBG14   %nsqxjhsh: outer blocks flush failed!%n
# M_JHSHDBG15   %nsqxjhsh: put_outer_rec() failed!!!%n
# M_JHSHDBG16   %nsqxjhsh: put_inner_rec failed during PHASE 2!%n
# M_JHSHDBG17   %nsqxjhsh: get_i_xbuf_rec failed during PHASE 2!%n
# M_JHSHDBG18   %nsqxjhsh: put_inner_rec: setup_obb() failed.
# M_JHSHDBG19   %nsqxjhsh: put_inner_rec: problem with sqxbwnx().
# M_JHSHDBG20   %nsqxjhsh: put_outer_rec: setup_obb() failed.
# M_JHSHDBG21   %nsqxjhsh: put_outer_rec: problem with sqxbwnx().
# M_JHSHDBG22   %nsqxjhsh: xform_key: keylen == %ld!!!%n

/*-- sqlplan.c --*/
# M_BADINSCORR  %1z%mINSERT statement does not permit correlation
!               with the table being inserted into.
# M_BADINSVAR   %1z%mThe reference to %32b appears to refer to
!               a variable in the table being inserted into.

/*-- sqxjhsh.c --*/
# M_JHSHDBG23   %nsqxjhsh: stash_o_r: problem with sqxbwnx().

/*-- sqxundo/ins/upd --*/
# M_UNDO_ERRS   reuse
# M_UNDO_REQD   %1z%mPROC SQL could not undo this statement if an
! ERROR were to happen as it could not obtain exclusive access
! to the data set. This statement will not execute as the SQL
! option UNDO_POLICY=REQUIRED is in effect.
# M_UNDO_NONE   %2z%mThe SQL option UNDO_POLICY=REQUIRED is not
! in effect. If an error is detected when processing this %s
! statement, that error will not cause the entire statement to fail.

/*-- sqxjhsh.c --*/
# M_JHSHDBG24   %nsqxjhsh: flush_stash() failed!%n
# M_JHSHDBG25   %nsqxjhsh: get_stash_rec() failed!!!%n

/*-- sqxextr.c --*/
# M_EXTERLYTRM  %2z%mOnly %ld records were read
!               from the CONNECTION to %*s due to INOBS= option.
# M_EXTTRUNC    %3z%mThe data value for column %*s (%*s) was
!               truncated or was out of range %ld times when
!               retrieving that data from the DBMS.

/*-- sqxsrc.c --*/
# M_SRC_V_F_NA  %1zThe sort order validation of SQL table
!               %8b.%*s failed.

# M_EXPREMISS   %3zInvalid arguments to the %*s function have caused
!               the function to return a missing value.

/*-- sqpexe.c --*/
# M_SQP_IS_SLCT %1zThe EXECUTE Statement cannot process SQL SELECT
!               queries.

/*-- sqprslv.c --*/
# M_SQP_NOTSLCT %1zThe SQL used in a CONNECTION TO <dbms> phrase
!               is not a SELECT expression.

/*-- sqlpooi.c --*/
# M_POOI_MJTHJ  %3zA merge join has been transformed to a hash join.

/*-- sqxundo/ins/upd --*/
# M_UNDO_NORAND %1zThis %s statement requires RANDOM access to the
!               data set being updated. The ERROR message above
!               indicates that this mode is not available.

/*-- sqxutil.c       --*/
# M_ERROR_MSG   %3z%m%s

# M_UNDO_INS    inserted
# M_UNDO_INS2   inserted into
# M_UNDO_UPD    updated
# M_UNDO_UPD2   updated in
# M_UNDO_A_1    %ld row was~
# M_UNDO_A_N    %ld rows were~
# M_UNDO_B      ~%8b.%32b -- of these~
# M_UNDO_C_1    %ll row was
# M_UNDO_C_N    %ll rows were
# M_UNDO_D      ~rejected as an ERROR, leaving~
# M_UNDO_E_1    %ll row that was~
# M_UNDO_E_N    %ll rows that were~
# M_UNDO_F      ~successfully.

/*-- sqxjhsh.c --*/
# M_JHSHNOSPACE %1zThere is not enough space to store some intermediate
!               results during join processing.
# M_RECBIGTBUF  %1zA record is bigger than its buffer allows.

/*-- sqlplan --*/
# M_FORCEINDEX  INFO: NOFORCEINDEX option influenced the strategy chosen
!               for this query.
# M_PLAN_SW_AO  INFO: %mIndex %*s of SQL table %8b.%*s (alias = %*s)
!               selected for SQL WHERE clause (outer join) optimization.
# M_PLAN_SW_NAO INFO: %mIndex %*s of SQL table %8b.%*s
!               selected for SQL WHERE clause (outer join) optimization.

/*-- sqlstmt.c --*/
# M_NOLONGTXT   %1zThe aggregate length of text accumulated for
!               SQL Passthru is limited to %ld.

/*-- sqldfr.c --*/
# M_OBYUNIQ     %2z%mThe query as specified involves ordering by
!               an item that doesn't appear in its SELECT clause.
!               Since you are ordering the output of a SELECT
!               DISTINCT it may appear that some duplicates have
!               not been eliminated.

/*-- sqxdlt.c --*/
# M_XDLT_UNDO   %3zDeletes were rolled back by the DBMS software.

/*-- sqlpbrn --*/
# M_PBRN_SW_A   INFO: %mIndex %*s of SQL table %8b.%*s (alias = %*s)
!               selected for SQL WHERE clause (%s subquery)
!               optimization.
# M_PBRN_SW_NA  INFO: %mIndex %*s of SQL table %8b.*s
!               selected for SQL WHERE clause (%s subquery)
!               optimization.

/*-- sqxslct --*/
# M_XSLCT_BADRANGE %2zINTO Clause :%32b through :%32b does not
!                  specify a valid sequence of macro variables.
# M_XSLCT_NOMEM    %2zran out of memory while forming INTO variable,
!                  value is truncated.

/*-- sqxmem.c --*/
# M_UTILBIG     %3zPROC SQL temporary work file has grown too large.

/*-- sqlsem.c --*/
# M_OUTOFPLACEOPT  %1zThe %*s= option is out of place. It should be in
!               the options list (which immediately comes after the
!               table name).

/*-- sqlpassi.c --*/
# M_ASYNCSTART %3zASYNC Log Start:
# M_ASYNCQUERY %-2n%3zQUERY: %s
# M_ASYNCGOOD  %3z-- Succeeded
# M_ASYNCFAIL  %3z** FAILED **
# M_ASYNCLOGB  %.*s
# M_ASYNCSUMM  %-2n%3zASYNC SUMMARY: %d queries, %d successful, %d failed

/*-- sqlpyac.yac --*/
# M_SQLP_PARSERR %1zParse Failure: %s

/*-- sqlphelp.h --*/
# M_SQLH_PREFIX   %3zCorrect Syntax for %s is:
# M_SQLH_SELECT   %3zSELECT objlist
!                 %-2nFROM tablelist
!                 %-2n[ WHERE boolean_expr ]
!                 %-2n[ GROUP BY scalar_expr { ',' scalar_expr }*  ]
!                 %-2n[ HAVING boolean_expr ]
!                 %-2n[ ORDER BY atomic_expr [ ASC | DESC ]
!                 %-2n     { ',' atomic_expr [ ASC | DESC ] }* ]
# M_SQLH_INSERT   %3zINSERT INTO tablespec [ '(' column { ',' column }* ')' ] {
!                 %-2n    { VALUES '(' constant { ',' constant }* ') }+
!                 %-2n  | { SET { column '=' value { ',' column '=' value }* }+ }+
!                 %-2n  | select_expr
!                 %-2n  }
# M_SQLH_UPDATE   %3zUPDATE tablespec
!                 %-2nSET column '=' value { ',' column '=' value }*
!                 %-2n[ WHERE boolean_expr ]
# M_SQLH_DELETE   %3zDELETE FROM tablespec
!                 %-2n[ WHERE boolean_expr ]
# M_SQLH_CRETBL   %3zCREATE TABLE tablespec {
!                 %-2n    '(' column_definition { ',' column_definition }* ')' |
!                 %-2n    AS select_expr |
!                 %-2n    LIKE tablespec
!                 %-2n  }
# M_SQLH_DRPTBL   %3zDROP TABLE tablespec { ',' tablespec }*
# M_SQLH_CREIDX   %3zCREATE [ UNIQUE ] INDEX indexname ON
!                 %-2n    tablespec '(' column { ',' column }* ')'
# M_SQLH_DRPIDX   %3zDROP INDEX indexname { ',' indexname }* FROM tablespec
# M_SQLH_LOADTBL  %3zLOAD TABLE tablespec
!                 %-2n[ WITH [ UNIQUE ] INDEX indexname ON '(' column_list ')'
!                 %-2n { ',' [ UNIQUE ] INDEX indexname ON '(' column_list ')' }* ]
!                 %-2nAS select_expr
# M_SQLH_COPYTBL  %3zCOPY TABLE tablespec FROM tablespec [ WITHOUT INDEXES ]
# M_SQLH_LIBREF   %3zLIBREF librefname [ ENGNAME '=' identifier ] [ ENGOPT '=' string ]
# M_SQLH_CONTENTS %3zCONTENTS tablespec [ VERBOSE [ '=' { TRUE | FALSE } ] ]
# M_SQLH_OPTION   %3zSET OPTION optionname [ '=' { YES|NO|number|string } ]
!                 %-2n    { ',' optionname [ '=' { YES|NO|number|string } ] }*
# M_SQLH_TOODEEP  %3zSPSD SQL Parser statements nested too deeply for context help

# M_OPT_BADTREE1  %1zset option: invalid tree code %d, expected SOPT
# M_OPT_BADTREE2  %1zset option: invalid name node, got %d, expected LITC/ASGN
# M_OPT_BADOPTNAM %2zset option: invalid option name (%s)
# M_OPT_BADARGCNT %2zset option: invalid argument count (%d) for option (%s), min/max = %d/%d
# M_OPT_BADARGTYP %2zset option: invalid argument type (%d) for option (%s), expected %d
# M_OPT_UNDOPOLIC %2zset option: invalid undo_policy argument (%s), expected REQUIRED,
!                 NONE or OPTIONAL
# M_OPT_INTERNAL  %1zset option: internal error, unexpected optcode %d

/*-- sqlpassi.c */
# M_ASYNC_SCON    %1zCannot execute 'connect to' statements within an ASYNC block

/*-- sqlpassi.c -- notify user that parallel group select method was chosen */
# M_SQL_PGRPSEL   %3zParallel group-select method chosen to execute this query.

/*-- sqpopt.c   -- mddb support */
# M_OPT_BADSQLGRM %2zset option: invalid SQL grammar (%s)
# M_ASYNC_MDBC    %1zCannot execute 'mddb create' statements within an ASYNC block

# 734  %3zThis insert failed while attempting to add
# 735  %1zThis insert failed due to duplicate/missing value.
# 736  %3zThis update failed due to duplicate/missing value.

# M_TRUNTHISSTUF %3zProcess a TRUNCATE statement.
# M_NOTTRUNCATED   %2z%s %8b.%*s has not been truncated.
# M_WASTRUNCATED   %3z%s %8b.%*s has been truncated.

# M_SQLH_BLOADTBL  %3zBLOCKLOAD TABLE tablespec

# M_SQLH_CLSTRCRTBL  %3zCLUSTER CREATE tablespec [options] WITH TABLE tablespec

# M_SQLH_CLSTRADDTBL  %3zCLUSTER ADD tablespec WITH TABLE tablespec

# M_SQLH_CLSTRUNDOTBL  %3zCLUSTER UNDO tablespec

/* SPQL blockload resuts */
# M_TBLBLKLD     %3zTable %8b.%*s blockload of %ll rows.

# M_SQLH_CLSTRREMTBL  %3zCLUSTER REMOVE TABLE tablespec FROM tablespec

# M_SQLH_GCLSTRCRTBL  %3zDISTRIBUTED CLUSTER CREATE tablespec [options] WITH TABLE tablespec DBQOPT = dbqopt

# M_SQLH_GCLSTRADDTBL  %3zDISTRIBUTED CLUSTER ADD tablespec WITH TABLE tablespec DBQOPT = dbqopt

# M_SQLH_GCLSTRREMTBL  %3zDISTRIBUTED CLUSTER REMOVE TABLE tablespec FROM tablespec

# M_SQLH_GCLSTRUNDOTBL  %3zDISTRIBUTED CLUSTER UNDO tablespec

# M_OPT_BADDIALECT %2zset option: invalid dialect (%s)

# M_POOI_MJTPJ  %3zA merge join has been transformed to a parallel join.

/*-- sqlpassi.c -- notify user that olap group select method was chosen */
# M_SQL_OGRPSEL   %3zOlap group-select method chosen to execute this query.

# M_OPT_BADJTECHPREF %2zset option: invalid jtech_pref (%s)

# M_SQLH_CLSTRREPTBL  %3zCLUSTER REPLACE TABLE tablespec WITH tablespec FROM tablespec

# M_WHENERROR3   %3zInvalid WHEN clause
